unit BIOS_IO; interface
  type shortcard = byte;

  var termo_attr:   byte;			     {    }
      termo_chars:  string[15]; 	{      }

  procedure hide_cursor;
    {-   }

  procedure show_cursor;
    {-   (     ) }

  procedure write_mem;
    {-         ( ) }

  procedure write_termo(x1, x2: byte; full, used: longint; var chng: longint);
    {-          . }
    {        x1,      x2.     }
    {          full .     }
    {    used  .  Chng      }
    {       .				      }

implementation
  uses DOS, BIOS_CRT;

  procedure hide_cursor;
    var r: registers;
  begin
    r.AH:= 3; r.BH:= screen_page; intr($10, r);
    r.AH:= 1; r.CH:= r.CH or $20; intr($10, r);
  end { hide_cursor };

  procedure show_cursor;
    var r: registers;
  begin
    r.AH:= 3; r.BH:= screen_page;  intr($10, r);
    r.AH:= 1; r.CH:= r.CH and $1f; intr($10, r);
  end { show_cursor };

  procedure write_mem;
    var r: registers;
	saveX, saveY, i: byte;
	s: string;
  begin { write_mem }
    r.AH:= 3; r.BH:= screen_page; intr($10, r);
    saveY:= r.DH; saveX:= r.DL;
    gotoXY(screen_cols -3, saveY+1);
    str((memAvail + 512) div 1024: 3, s);
    r.AH:= $0e;
    for i:= 1 to length(s) do begin
      r.AL:= ord(s[i]); intr($10, r);
    end { for };
    r.AH:= 8; r.BH:= screen_page; intr($10, r);
    r.BL:= r.AH; r.Cx:= 1; r.AL:= ord('k'); r.AH:= 9; intr($10, r);
    gotoXY(saveX+1, saveY+1);
  end { write_mem };

  procedure write_termo(x1, x2: byte; full, used: longint; var chng: longint);
    var r: registers;
	saveX, saveY, xpos: byte;
	wrk, t, empty: integer;
  begin { write_termo }
    if (full <= 0) or (used < 0) then exit;
    if used > full then used:= full;

    r.AH:= 3; r.BH:= screen_page; intr($10, r);
    saveY:= r.DH+1; saveX:= r.DL+1;
    xpos:= x1;
    empty:= (x2 -x1 +1);
    wrk:= empty * (length(termo_chars)-1);
    if wrk <= 0 then
      chng:= full
    else begin
      chng:= full div wrk;
      t:= trunc(0.5 + wrk * (used / full));
      x1:= t div (length(termo_chars) -1);
      x2:= t mod (length(termo_chars) -1);
      if x1 <> 0 then begin
	gotoxy(xpos, saveY);
	r.BL:= termo_attr;
	r.Cx:= x1;
	r.AL:= ord(termo_chars[length(termo_chars)]);
	r.AH:= 9; intr($10, r);
	dec(empty, x1); inc(xpos, x1);
      end { if };
      if x2 <> 0 then begin
	gotoxy(xpos, saveY);
	r.BL:= termo_attr;
	r.Cx:= 1;
	r.AL:= ord(termo_chars[1+x2]);
	r.AH:= 9;
	intr($10, r);
	dec(empty); inc(xpos);
      end { if };
      if empty <> 0 then begin
	gotoxy(xpos, saveY);
	r.BL:= termo_attr;
	r.Cx:= empty;
	r.AL:= ord(termo_chars[1]);
	r.AH:= 9;
	intr($10, r);
      end { if };
    end { if };
    gotoXY(saveX, saveY);
  end { write_termo };

  var r: registers;
begin
  r.AH:= 15; intr($10, r);
  screen_page:= r.BH;
  screen_cols:= r.AH;
  screen_mode:= r.AL;
  r.AH:= 8; intr($10, r);
  screen_attr:= r.AH;
					       {    }
  termo_attr:= r.AH and $0f;
  termo_chars:= ' ';
  if termo_attr > 7 then begin
    if r.AH and $f0 <> $70 then
      termo_attr:= termo_attr or $70;
    end
  else begin
    if (termo_attr <> 8) and (r.AH and $f0 <> $80) then
      termo_attr:= termo_attr or $80
    else begin
      termo_attr:= termo_attr or $10;
    end { if };
    if termo_attr and $80 <> 0 then begin
      termo_chars:= ' ';
      termo_attr:= (termo_attr div 16) + (termo_attr mod 16) * 16;
    end { if }
  end { if }
end { BIOS_IO }.
