{-----------------------------------------------------------------------------}
{ Lexical analisys interface part.                               (c) 1992 YGP }

  type symbol = (eof_sy,                       {      }
                 end_asm,                      {    END }
                 eol_sy,                           {      }
                 comment_line,                     {      }
                 instr_sy,   { MC68xx assembly instruction found (search cmd) }
                 alter_sy,               { alternate MC68xx instruction found }
                 drctv_sy,                { Assembly language directive found }
                 ident,
                 constant,   {     , , ... }
                 not_sy    {!},
                 dquote    {"},
                 dies      {#},           {   immediate address mode }
                 and_sy    {&},
                 quote     {'},
                 l_par     {(},
                 r_par     {)},
                 asterisk  {*},
                 plus_sy   {+},
                 comma     {,},
                 minus_sy  {-},
                 period    {.},
                 percent_sy{%},
                 slash_sy  {/},
                 colon     {:},
                 {semicolon ;,  = comment_line  }
                 less_sy   {<},
                 equ_sy    {=},
                 great_sy  {>},
                 l_bra     {[},
                 bslash_sy {\},
                 r_bra     {]},
                 xor_sy    {^},
                 or_sy     {|},
		 leq_sy    {<=},
		 geq_sy    {>=},
		 neq_sy    {<>},
                 string_sy,
                 space_sy,                    { space at the begining of line }
                 invalid_sy);

       directives = (d_define,             { conditional compilation (DEFINE) }
                     d_undef,                                       { (UNDEF) }
                     d_ifdef,                                       { (IFDEF) }
                     d_ifndef,                                     { (IFNDEF) }
                     d_if,                                             { (IF) }
                     d_else,                                         { (ELSE) }
                     {d_elsifdef,                                { (ELSIFDEF) }
                     {d_elsifNdef,                              { (ELSIFNDEF) }
                     {d_elsif,                                      { (ELSIF) }
                     d_endif,                                       { (ENDIF) }

                     d_equ,                                      { (EQU or =) }
                     d_error,                                       { (ERROR) }
                     d_global,                                     { (GLOBAL) }
                     d_include,               { include source file (INCLUDE) }
                     d_org,                                           { (ORG) }
                     d_radix,                                       { (RADIX) }

                     d_def_fcc,    { like DB but allow any string start (FCC) }
                     d_def_byte,                 { define byte directive (DB) }
                     d_def_lbyte,                      { define lo byte (LSB) }
                     d_def_hbyte,                      { define hi byte (MSB) }
                     d_def_word,                 { define word directive (DW) }
                     d_def_pword,     { * define positive byte sex word (DWP) }
                     d_def_nword,       { define negative byte sex word (DWN) }
                     d_def_long,                      { define long word (DD) }
                     d_def_plong, { * define positive byte sex longword (DDP) }
                     d_def_nlong,   { define negative byte sex longword (DDN) }
                     d_def_real,                    { define real (DR = REAL) }
                     d_def_space,               { define space directive (DS) }
                     d_def_ascz,        { define ASCIIz string (ASC = ASCIIZ) }
                     d_def_str,                { define string (STR = STRING) }
                     d_def_packed,              { define packed string (PACK) }
                     d_chksum,       { generate checksum directive (CHECKSUM) }
                                {           }
                                          {  CHECKSUM boza .. kosmata }
                                       {        }

                     d_list,                   { list on/off directive (LIST) }
                     d_as11,                   { as11 on/off directive (as11) }
                     d_intelbin,               { intel bin format constants }
                     d_trunc_list,       { truncate listing directive (TRUNC) }

                     d_procedure,                { start new procedure (PROC) }
                     d_entry,              { entry point in procedure (ENTRY) }
                     d_endproc,                        { end procedure (ENDP) }

                     d_section,               { start dummy section (SECTION) }
                     d_endsect,                    { end dummy section (ENDS) }

                     d_cmd,                                             { CMD }
                     d_pgm,                                             { PGM }
                     d_obj,                                             { OBJ }
                     d_bin,                                             { BIN }

                     d_MC6800,
                     d_MC6801,
                     d_MC68HC11,

                     d_end);                 { end assembly source code (END) }

       talk_type = (quiet,  {         }
                    talkfnames,      {        }
                    termometer,                    {     }
                    talkative);                  {     }

      instr_descriptor = packed record
        opcode, flags: byte;          { opcode to generate and special flags }
      end { instr_descriptor };

      ident_str = string[15];

      packed_name = array [0..4] of word;

  var sy:          symbol;                              { last token (symbol) }
      cc_compile,                        { conditional compilation true level }
      cc_level:    cardinal;          { conditional compilation nesting level }
      drctv:       directives;                         { last directive found }
      i_descr:     instr_descriptor;            { last instruction descriptor }
      talk_style:  talk_type;       {        }
      total_lines: longint;                            { total lines compiled }
      n_errors:    cardinal;                                 { errors counter }
      n_warnings:  cardinal;                               { warnings counter }
      lastlint:    longint;                    { last longint constant (insy) }
      lastreal:    real;                          { last real constant (insy) }
      err_sy:      symbol;                       {      }
      idnm:        ident_str;                 { last name (from token search) }
      radix:       2..16;           {    (-) }
      i_path:      stringp;                          { path for include files }
      sect_include,             {         section }
      proc_nesting,                                {    }
      inc_nesting,                           {   include  }
      wsize,                                                     { work space }
      pack_size:   shortcard;                   {     }
      wname,                                                     { work space }
      pack_name:   packed_name;                       {    }
      lst_line:    stringp; {           }
      lst_lno:     cardinal;                        { line number for listing }
      lst_inest:   shortint;              { include nesting level for listing }
      err_file:    text;                { file       }
      err_str:     stringp;

  procedure new_line;                                          (*) forward; (*)
    {   ,        .   SY = space_sy, }
    {            SY = comment_line, }
    {       ';'  '*',     .          }

  procedure skip_line;                                         (*) forward; (*)
    {         (  CR,LF)   SY = eol_sy }

  procedure insy;                                              (*) forward; (*)
    {     .                                           }

  procedure error(no: integer);                                (*) forward; (*)
    {        no                 }

  procedure ferror(fno:shortcard; lineno:cardinal; no:integer);(*) forward; (*)
    {  error     }

  procedure include_source((*)const{*)var{*} fname: string; path: stringp);
    {       (  ). }         (*) forward; (*)
    {      (fname)      . }

  procedure close_include;                                     (*) forward; (*)

  procedure search_cmd;                                        (*) forward; (*)
    {           .         }

  procedure get_str_no_quote(var s: string);                   (*) forward; (*)
    {        ,   ..     }
    {     include .                                   }

  procedure get_string(var s: string(*)[255](*));	       (*) forward; (*)
    {        }

  procedure skip_spaces;                                       (*) forward; (*)
    {      .    include .             }

  procedure wfname(clear, forced: boolean);                    (*) forward; (*)
    {         source   .        }

  function pack_ident((*)const{*)var{*} s: ident_str;
                 var result(*){*): packed_name{*}): shortcard; (*) forward; (*)

  procedure unpack_ident(sz: shortcard;
                        (*)const{*)var{*} packed_id: packed_name;
                         var s: ident_str);                    (*) forward; (*)

  function get_fno: shortcard;                                 (*) forward; (*)
    {      }

  function get_lno: cardinal;                                  (*) forward; (*)
    {         }

  procedure bump_fusage;                                       (*) forward; (*)

  procedure dec_fusage(fno: shortcard; check_only: boolean);   (*) forward; (*)

                                                         {$ifdef unimplemented}
  procedure unimplemented((*)const(*) text: string);           (*) forward; (*)
                                                                       {$endif}
{-----------------------------------------------------------------------------}
