;-----------------------------------------------------------------------------
; function pack_ident(var s: lab_str; var result): shortcard;
;
;   (*    3   2     : *)
;   (* '0'..'9' --> 0..9, 'A'..'Z' --> 10..35, '_' --> 36.  ,  *)
;   (*           & length <> 0 *)
;   (*        15 ( 10) *)
;   (*              *)
;   (*    (-     dec    0).     *)

interpreter     =       $befe
wrk             =       $b0
_3              =       $b1
w               =       $b2
wrks            =       $b4
size            =       $b6
wrkx            =       $b8

pack_ide        proc
                dw      0               ; to link with UniPascal
                ins
                ins                     ; pop return address
                plb
                pla                     ; get second parameter
                adda    #9              ; calc last byte address
                adcb    #0
                sta     w+1
                stb     w

                tsx
                ldx     x, 0            ; get first parameter
                ins
                ins                     ; pop first parameter
                lda     x, 0            ; get string size
                sta     patch+1         ; correct offset (read from end)
                clr     size

                sei
                sts     wrks
                lds     w
                bra     load_0_3
loop
patch           lda     x, 0            ; get next character
                dex
                cmpa    #'A'
                bmi     is_digit
                cmpa    #'_'
                beq     is_underscore
                suba    #'A'-10         ; 'A'..'Z' --> 10..35
                bra     OK
is_underscore   lda     #36+'0'         ; '_'      --> 36
is_digit        suba    #'0'            ; '0'..'9' --> 0..9
                bmi     end_ident       ;      < '0'
OK
fill_word
                sta     wrk
                lda     w+1             ; 40*w = 8*(4+1)*w = 8*(4*w+w)
                ldb     w
                asla
                rolb
                asla
                rolb                    ; w times 4
                adda    w+1
                adcb    w               ; w times 5
                asla
                rolb
                asla
                rolb
                asla
                rolb                    ; w times 40
                adda    wrk             ; w = w*40 + wrk
                adcb    #0

                dec     _3
                bne     not_0
                inc     size
                phb                     ; store result
                pha
load_0_3
                lda     #3
                sta     _3
                clrb
                clra
not_0           sta     w+1
                stb     w
                bra     loop
end_ident       inx
                lda     #39
                ldb     _3
                cmpb    #3
                bne     fill_word       ; fill to full word

                lds     wrks
                cli
                lda     size
                clrb                    ; push function result
                phb
                pha
                jmp     interpreter     ; return to interpreter
                endp; pack_ident

;-----------------------------------------------------------------------------
; procedure unpack_ident(sz: shortcard;
;                        const packed_id: packed_name; var s: ident_str);
unpack_i        proc
                dw      0
                tsx
                ldx     x, 2            ; string address
                stx     wrkx
                tsx
                lda     x, 6            ; sz
                sta     size
                beq     zero_size
                suba    #5
                nega
                asla                    ; times 2
                clrb
                adda    x, 5            ; calc packed_id[5-sz]
                adcb    x, 4
                sta     x, 5
                stb     x, 4

                ldx     x, 4
                sei
                sts     wrks
                txs
loop
                lda     #3
                sta     _3
                pla
                plb
                bra     div_40
loop_3
                lda     w+1
                ldb     w

div_40          proc
                ldx     #17
shift           sec
                rola
                rolb
                dex
                bcc     shift
                beq     is_0
                sta     w+1             ; 
                stb     w
                lda     #0              ; CLRA ==> clc
                tab                     ;  

d_loop          rola
                rolb
                suba    #40
                sbcb    #/40
                bcc     ok
                adda    #40
                adcb    #/40
ok              rol     w+1
                rol     w
                dex
                bne     d_loop
                com     w+1
                com     w
                db      $81
is_0            clra
                endp; div_40

                cmpa    #10
                bcc     geq_10
                adda    #'0'
                bra     store
geq_10          cmpa    #36
                bcc     geq_35
                adda    #'A'-10
                bra     store
geq_35          bne     great_36
                lda     #'_'
store           ldx     wrkx
                inx
                stx     wrkx
                sta     x, 0
great_36        dec     _3
                bne     loop_3
                dec     size
                bne     loop
                lds     wrks
                cli
zero_size       tsx                     ; return address
                lda     wrkx+1
                suba    x, 3
                ldx     x, 2
                sta     x, 0            ; string size
                ins
                ins
                ins
                ins
                ins
                ins
                ins
                ins
                jmp     interpreter
                endp; unpack_ident

                public  pack_ide;nt
                public  unpack_i;dent